# 仅仅自己使用!!!!!!!!!!!!!!!

# 基于create-react-app，使其可配置
create-react-app使用起来很优雅很舒服，可是其对我们项目来说缺少了很多我们想要的个性功能，比如less等，故我简单的弄了这个库，使得create-react-app可配置，通过在项目根目录下新增config.js文件，进行相关的配置设置，同时为了支持更新的语法支持，例如用mobx时的修饰器，可以在babelrc中新增presets或者plugins，下面有配置的举例，该配置文件会被读取到babel-loader的配置项中进行覆盖，使得我们项目可随意新增新特性

## 特性

1. 默认支持了less css-modules
2. 新增config配置文件，可以对webpack进行相关配置
3. 默认支持dllplugin包分离，但需要用户在config配置vendors字段
4. 默认支持typescript

## 使用简单，只需两步

1. 使用`npm install ers` 或者 `yarn add ers`
2. 在package.json的script字段中配置如下：
```json
"scripts": {
  "start": "ers start",
  "build": "ers build"
}
```

## babel可配置
通过配置babelrc，将其所有配置将自动提取到babel-loader，避免单独的babel-loader配置，如果没有babelrc文件配置，将按照cra默认的presets==>react-app进行
```json
//for example：
{
  "presets": ["env"],
  "plugins": [
    "transform-decorators-legacy",
    ["import", { 
      "libraryName": "antd", 
      "style": true 
    }]
  ]
}
```

## config文件配置如下：

```javascript
 //可以引入相关webpack生态的插件Ï
var ProgressBarPlugin = require("progress-bar-webpack-plugin");

module.exports = {
  //该项为供需要分离打包的包的设置字段 无此字段或者标记为null字段则不启用包分离
  vendors: ["react", "react-dom"],
  //也支持对象,将打成多个vendorÏ
  vendors:{
    vendor1: ["react","react-dom"],
    vendor2: ['lodash','moment']
  }
  //以下为需要新增的lodaer 目前已经支持css  less ，若需要其余的loader，请在以下字段添加
  loaders: [],
  //此项配置为less-loader使用，覆盖less的变量设置，例如ant.design的less变量
  modifyVars:{},
  //以下为plugin字段，若有需要可以在此覆盖或者添加，为了便于管理，开发环境和生产环境分开
  //生产环境
  prodPlugins: [new ProgressBarPlugin()],
  //开发环境
  devPlugins: [new ProgressBarPlugin()],
  //以下配置别名 //注意  以下所有的路径只允许为src目录以下，且不用再包含src  比如src文件夹下有一个index.js文件，则只需要'/index.js'即可
  alias: {
    API: "/api"
  },
};
```

## 更新

|版本号|备注|
|--|--|
|0.2.5|ts和tsx增加了babel-loader,以便使用babel的插件|
|0.2.2|针对最新版本的rs进行了更新,并新增了happypack,并发压缩,dll plugin,等等多种优化手段,以提升打包速度;移除对typescript的支持|
|0.1.7|config文件新增对modifyVars的支持|
|0.1.6|新增对typescript的支持|

## Others

其余的配置和设置等均与create-react-app相同
